<?php
/*
* 2007-2015 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2015 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
require_once(_PS_MODULE_DIR_.'leo_emailsmanager/leo_emailsmanager.php');
class leo_emailsmanagerDesignTemplateModuleFrontController extends ModuleFrontController
{
    public function initContent()
    {
        $tplName = basename(Tools::getValue('template'));
        Media::addJsDef(array('mails_img_url' => _PS_IMG_.'emails/'.$tplName.'/'));
        if (!$tplName || $tplName == '') {
            $this->_errors[] = $this->l('Invalid template\'s name');
            return false;
        }
        // $translations = $this->getEmailsTranslations($language['iso_code']);

        // var_dump($translations);die();
        $lang = Context::getContext()->language->iso_code;

        // var_dump($tplpath[2]);die();
        $tplpath2 = scandir(_PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/');
        if($tplName == Context::getContext()->shop->theme_name){
            echo "not found template";
            die();
        };
        if($tplpath2){
            $path_file = array();
           foreach ($tplpath2 as $file) {
            if($file != '.' && $file != '..' && preg_match('/\.tpl/', $file, $matches)){
                array_push($path_file, $file);
            }
        }

        if (version_compare(_PS_VERSION_, '1.7', '>=')) {
            $theme_custom = Tools::strtoupper(Context::getContext()->shop->theme->getName());
        } else {
            $theme_custom = $this->context->shop->id_theme;
        }
        
        $settings = Tools::jsonDecode(Tools::file_get_contents(_PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/settings.json'), true);
        $usersettings  = array();
        $usersettings = Tools::jsonDecode(Configuration::getGlobalValue('LEODEMO_' . $theme_custom), true);

        for($i=0;$i<count($settings['inputs']);$i++){
            foreach ($usersettings['inputs'] as $key => $value) {
                if($settings['inputs'][$i]['name'] == $key){
                    if(isset($settings['inputs'][$i]['default'])){
                        $settings['inputs'][$i]['default'] = $value;
                    }
                    if(isset($settings['inputs'][$i]['demo'])){
                        $settings['inputs'][$i]['demo'] = $value;
                    }
                }
            } 
        }

        // get content settting json
        $config  = array();
        if (!empty($settings['inputs'])) {
            foreach ($settings['inputs'] as $key => $value) {
                $config[$value['name']] = array(
                    'default'   =>  $value['default'],
                    'label'     =>  $value['label'],
                    'desc'      =>  $value['desc'],
                    'lang'      =>  $value['lang'],
                    'required'  =>  $value['required'],
                    'type'      =>  $value['type'],
                    'datasource'      => isset($value['datasource']) ? $value['datasource'] : '',
                    'dataaction'      => isset($value['dataaction']) ? $value['dataaction'] : ''
                );
                if(isset($value['demo'])){
                    $config[$value['name']]['demo'] = $value['demo'];
                }
            }
        }

        // get content settting sidebar
        $config_sidebar  = array();
        if (!empty($config)) {
            $config_sidebar['general']  = array();
            $config_sidebar['header']   = array();
            $config_sidebar['nav']      = array();
            $config_sidebar['content']  = array();
            $config_sidebar['footer']   = array();
            $config_sidebar['social']   = array();

            foreach ($config as $key => $value){
                // print_r($value);
                $value['name'] = $key;
                // ($value['type'] == 'color') ? str_replace('#','',$value['default']) : $value['default'];
                if(strpos($key, '_text_input_') !== false){
                    $value['type'] = 'text-input';
                }elseif(strpos($key,'font_family') !== false){
                    $value['type'] = 'font-family';
                }

                if(strpos($key,'group_social') !== false){
                    //$value['type'] = 'radio';
                    array_push($config_sidebar['social'],$value);
                }elseif(strpos($key, 'group_footer') !== false){
                    array_push($config_sidebar['footer'],$value);
                }elseif(strpos($key, 'group_content') !== false){
                    array_push($config_sidebar['content'],$value);
                }elseif(strpos($key, 'group_nav') !== false){
                    array_push($config_sidebar['nav'],$value);
                }elseif(strpos($key, 'group_header') !== false){
                    array_push($config_sidebar['header'],$value);
                }else{
                    array_push($config_sidebar['general'],$value);
                }
            }
        }

        $this->context->smarty->assign("config_sidebar", $config_sidebar);
        // $this->context->smarty->assign("configuration_settings", $config);
        $this->context->smarty->assign("path_file", $path_file);
        $this->context->smarty->assign("url",__PS_BASE_URI__.'?fc=module&module=leo_emailsmanager&controller=DesignTemplate&template='.$tplName);
        };

        if(Tools::getValue('type') == 'saveEmailTemplate'){
            $file = Tools::getValue('folder');
            $lang = Tools::getValue('lang');
            $html = Tools::getValue('html');

            $url1 = _PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/settings.json';
            $url2 = _PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/default_settings.json';
            if (!file_exists($url2)) {
                Tools::copy($url1, $url2);
            }

            if (version_compare(_PS_VERSION_, '1.7', '>=')) {
                $theme_custom = Tools::strtoupper(Context::getContext()->shop->theme->getName());
            } else {
                $theme_custom = $this->context->shop->id_theme;
            }


            $currentTpl = Tools::jsonDecode(Configuration::getGlobalValue('LEODEMO_'.$theme_custom));
            
            $url_file = _PS_THEME_DIR_.'mails/'.$lang.'/'.str_replace('.tpl', '.html', $file);

            if($currentTpl->name == $tplName && file_exists($url_file) && filesize($url_file)){
                $fn = fopen($url_file,"r");
                $status = 1;
                $html_content = '';
                  while(! feof($fn))  {
                    $result = fgets($fn);
                    $pattern = preg_quote('<body>', '/');
                    $pattern = "/^.*$pattern.*\$/m";
                    if($status == 1){
                        $html_content .= $result;
                    }
                    if(preg_match_all($pattern, $result, $matches)){
                        $status = 0;
                    }
                }

                fclose($fn);
                
                $html_content .= $html;
                $html_content .= '</body>';
                $html_content .= '</html>';

                $status = file_put_contents($url_file,$html_content);
            }
            
            $list_lang = Language::getLanguages(true, $this->context->shop->id);
            $id_lang = 1;
            foreach ($list_lang as $key => $value) {
                if ($value['iso_code'] == $lang){
                    $id_lang = $value['id_lang'];
                }
            }

            $config = Tools::getValue('config');
            foreach ($usersettings["inputs"] as $key => &$setting_value) {
                foreach ($config as $key2 => $config_value) {
                    if($key == $config_value[0]){
                        if(gettype($setting_value) == "array"){
                            $setting_value[$id_lang] = $config_value[1];
                        }else{
                            $setting_value = $config_value[1];
                        }
                        
                    }
                }
            }

            Configuration::updateGlobalValue('LEODEMO_'.$theme_custom, Tools::jsonEncode($usersettings));

//            $status = file_put_contents(_PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/settings.json',json_encode($settings));
            
            if($status){
                echo $this->l('Update Template success');
            }else{
                echo $this->l('Have error when update');
            }
            die();
        }

        if (Tools::getValue('type') == 'resetConfiguration') {
            if(Configuration::getGlobalValue('LEODEMO_OLD_' . $theme_custom)){
                Configuration::updateGlobalValue('LEODEMO_'.$theme_custom, Configuration::getGlobalValue('LEODEMO_OLD_' . $theme_custom));
            }
            
            $html1 = _PS_MODULE_DIR_.$this->module->name.'/compile/'. Tools::getValue('template') . '/' . Tools::getValue('lang') . '/' .str_replace('.tpl', '.html', $_POST['file']);
            $html2 = _PS_THEME_DIR_.'mails/' . Tools::getValue('lang') . '/' .str_replace('.tpl', '.html', $_POST['file']);

            if (file_exists($html1)) {
                file_put_contents($html2, Tools::file_get_contents($html1));
            }

            echo Tools::getHttpHost(true).__PS_BASE_URI__ . 'module/leo_emailsmanager/DesignTemplate?template=' . $tplName;
            die;
        }

        if(Tools::getValue('type') == 'select_template'){ 

            $current = json_decode(Configuration::get('LEODEMO_'.$this->module->getCurrentThemeId()), true);

            $result_json =  array();

            // get string file .tpl
            $file = Tools::getValue('folder');
            $lang = Tools::getValue('lang');

            $url_html = _PS_THEME_DIR_.'mails/' . $lang . '/' .$file;
            $url_html = str_replace('.tpl', '.html', $url_html);
            if(file_exists($url_html) && $current['name'] == Tools::getValue('template')){
                $ml = Tools::file_get_contents($url_html);
                $ok =$this->module->translateTemplate($ml, $this->module->getEmailsTranslations($lang));
                $templateVars = $this->getEmailsVars();
                foreach ($templateVars as $key => $var) {
                    if ($key == '{shop_logo_'.$tplName.'}'){
                        $ok = str_replace('{shop_logo}', $templateVars['{shop_logo_'.$tplName.'}'], $ok);
                    }else{
                        $ok = str_replace($key, $var, $ok);
                    }
                }
                $ok = str_replace("<!doctype html>", "", $ok);

                $result_json['html'] = $ok;
            }else{
                if(is_dir(_PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName)){
                    if(file_exists(_PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/'.$file)){
                        $ml = Tools::file_get_contents(_PS_MODULE_DIR_.$this->module->name.'/imports/'.$tplName.'/'.$file);
                        $ok =$this->module->translateTemplate($ml, $this->module->getEmailsTranslations($lang));
                        $templateVars = $this->getEmailsVars();
                        foreach ($templateVars as $key => $var) {
                            if ($key == '{shop_logo_'.$tplName.'}'){
                                $ok = str_replace('{shop_logo}', $templateVars['{shop_logo_'.$tplName.'}'], $ok);
                            }else{
                                $ok = str_replace($key, $var, $ok);
                            }
                        }
                        $ok = str_replace("<!doctype html>", "", $ok);

                        $result_json['html'] = $ok;
                    }
                }
            }

            // settings.json
            $result_json['settings'] = $config;

            die(Tools::jsonEncode($result_json));
        }

        $this->context->smarty->assign(array('languages' => Language::getLanguages(true, $this->context->shop->id)));

        $this->setTemplate('module:leo_emailsmanager/views/templates/front/designtemplate.tpl');
        parent::initContent();
    }

    public function rendertemplate($tpl="",$lang="")
    {
        $template = basename(Tools::getValue('template'));

        if (!Validate::isTplName($template)) {
            Tools::redirectAdmin(Context::getContext()->link->getAdminLink('AdminModules'));
        }

        if ($this->module instanceof Module) {
            if ($template == 'classic') {
                $link = _PS_MODULE_DIR_.$this->module->name.DIRECTORY_SEPARATOR.'imports'.DIRECTORY_SEPARATOR;
                $link .= 'classic'.DIRECTORY_SEPARATOR.'en'.DIRECTORY_SEPARATOR.'account.html';
                $templateContent = Tools::file_get_contents($link);
                if (!$templateContent) {
                    die(Tools::displayError('Invalid classic template'));
                }
            } else {
                // Get template's settings from it's json file
                $settings = $this->module->getTemplateSettings($template);
                $current = json_decode(Configuration::get('LEODEMO_'.$this->module->getCurrentThemeId()), true);

                if (!isset($settings['inputs']) || !is_array($settings['inputs'])) {
                    die(Tools::displayError('Invalid template'));
                }

                $id_lang = Context::getContext()->language->id;
                $iso_lang = Context::getContext()->language->iso_code;

                foreach ($settings['inputs'] as $input) {
                    $value = Tools::getValue($input['name']);
                    if ($current['name'] == $template && isset($current['inputs'][$input['name']])) {
                        if (isset($input['lang']) && $input['lang'] == true) {
                            $this->context->smarty->assign($input['name'], isset($current['inputs'][$input['name']][$id_lang]) ? $current['inputs'][$input['name']][$id_lang] : '');
                        } else {
                            $this->context->smarty->assign($input['name'], $current['inputs'][$input['name']]);
                        }
                    } elseif ($value) {
                        $this->context->smarty->assign($input['name'], $value);
                    } else {
                        if (isset($input['lang']) && $input['lang'] == true) {
                            $this->context->smarty->assign($input['name'], isset($input['default'][$iso_lang]) ? $input['default'][$iso_lang] : '');
                        } else {
                            $this->context->smarty->assign($input['name'], $input['default']);
                        }
                    }
                }

                $this->context->smarty->assign($this->module->getTplVariables());

                // Change smarty delimiters to ease the parsing process
                $this->context->smarty->left_delimiter = '{{';
                $this->context->smarty->right_delimiter = '}}';
    
                $translations = $this->module->getEmailsTranslations($lang);
                $file = _PS_MODULE_DIR_.$this->module->name.DIRECTORY_SEPARATOR;
                $file .= 'imports'.DIRECTORY_SEPARATOR.$template.DIRECTORY_SEPARATOR.$tpl;
                $templateContent = $this->context->smarty->fetch($file);
                $templateContent = $this->module->translateTemplate($templateContent, $translations);

                // Restore default smarty delimiters
                $this->context->smarty->left_delimiter = '{';
                $this->context->smarty->right_delimiter = '}';
            }

            // Replace email's variables with not so fake data
            $templateVars = $this->getEmailsVars();
            foreach ($templateVars as $key => $var) {
                $templateContent = str_replace($key, $var, $templateContent);
            }
            $result_json['html'] = str_replace("<!doctype html>", "", $templateContent);
            die(Tools::jsonEncode($result_json));
        }
    }

    protected function getEmailsVars()
    {
        $templateVars = array();

        $idShop = Context::getContext()->shop->id;

        $configuration = Configuration::getMultiple(array(
            'PS_SHOP_EMAIL',
            'PS_SHOP_NAME',
            'PS_LOGO',
            'PS_LOGO_MAIL'
        ), null, null, $idShop);

        if ($configuration['PS_LOGO_MAIL'] !== false && file_exists(_PS_IMG_DIR_.$configuration['PS_LOGO_MAIL'])) {
            $templateVars['{shop_logo}'] = $this->context->shop->getBaseURL().'img/'.$configuration['PS_LOGO_MAIL'];
        } else {
            if (file_exists(_PS_IMG_DIR_.$configuration['PS_LOGO'])) {
                $templateVars['{shop_logo}'] = $this->context->shop->getBaseURL().'img/'.$configuration['PS_LOGO'];
            } else {
                $templateVars['{shop_logo}'] = '';
            }
        }

        if ((Context::getContext()->link instanceof Link) === false) {
            Context::getContext()->link = new Link();
        }

        $templateVars['{shop_name}'] = Tools::safeOutput($configuration['PS_SHOP_NAME']);
        $templateVars['{shop_url}'] = Context::getContext()->link->getPageLink(
            'index',
            true,
            Context::getContext()->language->id,
            null,
            false,
            $idShop
        );
        $templateVars['{firstname}'] = 'John';
        $templateVars['{lastname}'] = 'Doe';
        $templateVars['{email}'] = Tools::safeOutput($configuration['PS_SHOP_EMAIL']);
        $templateVars['{passwd}'] = '12345'; // PS < 1.7
        $dd = Tools::jsonDecode(Tools::file_get_contents(_PS_MODULE_DIR_.$this->module->name.'/fake.json'), true);
        $templateVars = $dd;
          // $templateVars['{order_name}'] = $dd['order_name'];
      return;
        return $templateVars;
    }
}
